<script setup lang="ts">
import { useAuthStore } from '@/stores/auth'
import { useLoadingStore } from '@/stores/loading'
import { useNavStore } from '@/stores/navigation'
import { onUnmounted } from 'vue'
import { onMounted } from 'vue'
import { ref } from 'vue'

const authStore = useAuthStore()
const navigation = useNavStore()
const email = ref()
const password = ref('')
const validForm = ref(false)
const loading = ref(false)

const onSubmit = () => {
  if (validForm.value) {
    authStore.login(email.value, password.value)
  }
}
const usernameRules = [(v: string) => !!v || 'Username is required']
const passwordRules = [(v: string) => !!v || 'Password is required']
const showError = ref(false)

const loader = useLoadingStore()

onMounted(() => {
  navigation.hideNavLayout()
})

onUnmounted(() => {
  navigation.showNavLayout()
})
</script>

<template>
  <v-container fluid>
    <div>
      <video autoplay loop muted>
        <source src="../assets/coffee-vdo-bg.mp4" type="video/mp4" />
        Your browser does not support the video tag.
      </video>
    </div>
    <v-img class="mx-auto my-3" max-width="280" src="src/assets/MainLogo.png" />
    <v-card
      class="mx-auto pa-12 pb-8 transparent-card custom-card"
      elevation="0"
      max-width="448"
      rounded="lg"
    >
      <template #loader> <v-progress-linear v-if="loading" indeterminate /></template>
      <v-form class="mx-auto" @submit.prevent="onSubmit" v-model="validForm">
        <div class="text-subtitle-1 text-medium-emphasis my-1">Email</div>
        <v-text-field
          required
          density="compact"
          placeholder="Enter your username"
          variant="outlined"
          v-model="email"
          :rules="usernameRules"
        ></v-text-field>

        <div class="text-subtitle-1 text-medium-emphasis d-flex align-center justify-space-between">
          Password
        </div>

        <div>
          <v-text-field
            required
            density="compact"
            type="password"
            placeholder="Enter your password"
            class="my-1"
            variant="outlined"
            v-model="password"
            :rules="passwordRules"
          >
          </v-text-field>
          <h5 v-if="showError" class="text-error text-center">
            **User not found or incorrect password !
          </h5>
        </div>
        <div>
          <v-btn
            :loading="loader.isLoading"
            :disabled="!validForm"
            type="submit"
            rounded
            block
            class="mb-4"
            color="orange"
            size="large"
          >
            <p class="font-weight-bold">Login</p>
          </v-btn>
        </div>
      </v-form>
    </v-card>
    <h5 class="text-grey d-flex justify-center mt-12">
      For Education Only. © 2023 D-Coffee, SimpleDev Team. All right reserved.
    </h5>
  </v-container>
</template>
<style scoped>
.custom-card {
  border: 2px solid transparent;
}

a:hover {
  color: #000;
}

video {
  position: fixed;
  top: 50%;
  left: 50%;
  transform: translate(-50%, -50%);
  min-width: 100%;
  min-height: 100%;
  object-fit: cover;
  z-index: -1;
}

.transparent-card {
  background: rgba(0, 0, 0, 0.9);
}
</style>
